import pandas as pd
import numpy as np
from sklearn import linear_model
from sklearn import preprocessing, svm
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression
from sklearn.compose import ColumnTransformer
from sklearn.preprocessing import OneHotEncoder
import warnings
warnings.filterwarnings("ignore")
df = pd.read_csv('Database_Final.csv')

df.dropna(inplace = True)

# print(df.head())

encoded = pd.get_dummies(df[['Date', 'Time', 'Weather', 'Parking']], drop_first=True)
# df.dropna([columns=['Date', 'Time', 'Weather', 'Parking'], inplace=True)
df = df.join(encoded)

# print(df.head())

df['target'] = df['Remaining space']

df = df.drop(columns=['Unnamed: 0', 'Remaining space', 'ID', 'Date', 'Time', 'Weather', 'Parking'])

# print(df.tail())
my_list = list(df)
# print(my_list)
x = df.iloc[:, :-1].values
y = df.iloc[:, -1].values

X_train, X_test, y_train, y_test = train_test_split(x, y, test_size=0.25)

regr = LinearRegression()

regr.fit(X_train, y_train)
# print(regr.score(X_test, y_test))

# print(regr.predict([[14,7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]]))

date = ['Monday', 'Saturday', 'Sunday', 'Thursday', 'Tuesday', 'Wednesday']
weather = ['rainy', 'sunny', 'cloudy']
parking = ['BAMBALAPITIYA', 'BORELLA', 'KOLLUPITIYA', 'WELLAWATHTHA']
time = ['0700 - 0715', '0715 - 0730', '0730 - 0745', '0745 - 0800', '0800 - 0815', '0815 - 0830', '0830 - 0845',
        '0845 - 0900']

Date_i = input('Date: [Monday, Saturday, Sunday, Thursday, Tuesday, Wednesday] : select a value 1 - 6 :')
Time_i = input('Time: [0700 - 0715, 0715 - 0730, 0730 - 0745, 0745 - 0800,0800 - 0815, 0815 - 0830, 0830 - 0845,0845 - 0900] : select a value 1 - 8 :')
Weather_i = input('Weather: [rainy, sunny, cloudy] : select a value 1 - 3 :')
Parking_i = input('Parking: [BAMBALAPITIYA, BORELLA, KOLLUPITIYA, WELLAWATHTHA] : select a value 1 - 4 :')
Entry = input('Entry :')
Exit = input('Exit :')


Date = date[int(Date_i) - 1]
Time = time[int(Time_i) - 1]
Weather = weather[int(Weather_i) - 1]
Parking = parking[int(Parking_i) - 1]

def norm(r):
    if(int(r) < 0):
        return 0
    else: return r

def encode(Date,Time,Weather,Parking,Entry,Exit):
    date = ['Monday', 'Saturday', 'Sunday', 'Thursday', 'Tuesday', 'Wednesday']
    date_val = [[1,0,0,0,0,0],[0,1,0,0,0,0],[0,0,1,0,0,0],[0,0,0,1,0,0],[0,0,0,0,1,0],[0,0,0,0,0,1]]
    weather = ['rainy', 'sunny', 'cloudy']
    weather_val = [[1, 0], [0, 1], [0, 1]]
    parking = ['BAMBALAPITIYA','BORELLA', 'KOLLUPITIYA', 'WELLAWATHTHA']
    parking_val = [[1, 0, 0],[1, 0, 0], [0, 1, 0], [0, 0, 1]]
    time = ['0700 - 0715', '0715 - 0730', '0730 - 0745', '0745 - 0800', '0800 - 0815', '0815 - 0830', '0830 - 0845', '0845 - 0900']
    time_val = [[1,0,0,0,0,0,0],[1,0,0,0,0,0,0],[0,1,0,0,0,0,0],[0,0,1,0,0,0,0],[0,0,0,1,0,0,0],[0,0,0,0,1,0,0],[0,0,0,0,0,1,0],[0,0,0,0,0,0,1]]
    listofval = []
    listofval.append([Entry,Exit])
    j = 0
    for i in date:
        if(Date == i):
            k = date_val[j]
            listofval.append(k)
        j+=1
    a = 0
    for i in weather:
        if(Weather == i):
            k = weather_val[a]
            listofval.append(k)
        a+=1
    b = 0
    for i in parking:
        if(Parking == i):
            k = parking_val[b]
            listofval.append(k)
        b+=1
    c = 0
    for i in time:
        if(Time == i):
            k = time_val[c]
            listofval.append(k)
        c+=1

    flattened = [val for sublist in listofval for val in sublist]
    # print(flattened)

    return flattened


inpt = encode(Date,Time,Weather,Parking,Entry,Exit)

s = regr.predict([inpt])
r = int(round(s[0]))
# print(r)
out = norm(r)

print(f'remaining parking slots are {out}.')

# encoded = pd.get_dummies(myvar[['Date', 'Time', 'Weather', 'Parking']], drop_first=True)
# myvar = myvar.join(encoded)

# myvar = myvar.drop(columns=['Date', 'Time', 'Weather', 'Parking'])

# print(encoded)